import { GildedRose } from './gilded-rose'
import { Item } from './item'
  
const items = [
  createNormalItem('+5 Dexterity Vest', 10, 20),
  createAgedBrie(2, 0),
  createNormalItem('Elixir of the Mongoose', 5, 7),
  createSulfuras(0, 80),
  createSulfuras(-1, 80),
  createBackStagePass(15, 20),
  createBackStagePass(10, 49),
  createBackStagePass(5, 49),
  createBackStagePass(1, 20),
  // this conjured item does not work properly yet
  createNormalItem('Conjured Mana Cake', 3, 6),
]

const app = new GildedRose(items)
const days = 3
const result = []

result.push('OMGHAI')
for (let i = 0; i < days; i++) {
  result.push(`-------- day ${i} --------`)
  result.push('name, sellIn, quality')
  for (const item of items) {
    result.push(item.toString())
  }
  result.push('')
  app.update_quality()
}

console.log(result.join('\n'))
